%% nmos1

%%

clear
load spice
d = N1u();
disp(d)

%%

VSB = 0;
VGS = 2;
VT = d.VTO;


e0 = 8.85e-12;
eox = 3.8*e0;
COX  = eox/d.TOX;

us = d.UO/(1+d.THETA*abs(VGS-VT));
k = us*COX*1e-4; % contains conversion from m^2 to cm^2
disp('calculate KP');
disp(k)
disp('given KP');
disp(d.KP)

%%

L = 2e-6;
W = 10e-6;

Leff = L - 2*d.LD;

COX = eox/d.TOX;
sigd = (8.15e-22)*d.ETA/(COX*Leff^3);
disp('sigma d');
disp(sigd)

%%

beta = k*W/Leff;

FS = 1;
FB = d.GAMMA*FS;


VDsat = (VGS-VT)/(1+FB);

VDS = linspace(0,5,100);
%sigd = 8e-3;
idx = find(VDS<VDsat);
v = VDS(idx);
Vt = VT - sigd*v;
Id = beta*((VGS-Vt).*v - (1+FB)*v.^2/2);
idx = find(VDS>=VDsat);
v = VDS;
Vt = VT - sigd*VDS(idx);
Id(idx) = 0.5*beta*(VGS-Vt).^2/(1+FB);

plot(spice.vds,spice.data(:,1)*1e3,'--',v,Id*1e3);
xlabel('V_{DS} (V)');
ylabel('I_d (mA)');

